using System;
using System.Collections.Generic;
using System.Web.UI.WebControls;
using DotNetNuke.Entities.Modules;
using DotNetNuke.Services.Exceptions;
using DotNetNuke.Entities.Modules.Actions;
using DotNetNuke.Security;
using DotNetNuke.Services.Localization;
using NBrightCore.common;
using NBrightCore.render;
using NBrightDNN;

namespace DotNetNuke.Modules.NBrightStore
{
	public partial class AdminConfig : NBrightStoreAdminBase
    {
        string configSec = "";

        override protected void OnInit(EventArgs e)
        {
			//Set base EntityTypeCode, MUST be done for all NBright child ctrls before OnInit
			// no data save on dashdoard so clear values
			base.EntityTypeCode = "";
			base.EntityTypeCodeLang = "";
			base.CtrlTypeCode = "AdminConfig";

            base.OnInit(e);

			var configDic = Utils.ConfigBuildDictionary(MapPath(ControlAdminPath + "NBrightConfig\\NBrightStore.config"), PortalSettings.HomeDirectoryMapPath + "NBrightConfig\\NBrightStore.config");
        	var configSecList = Utils.ConfigBuildSectionList(configDic);
        	var headTempl = "[<tag id='resourcepath' type='meta' value='/DesktopModules/NBright/NBrightStore/App_LocalResources/' />]";
			headTempl += "<div class='NBright_ButtonDiv'>";
			headTempl += "[<tag id='cmdSaveConfig' type='linkbutton' resourcekey='General.cmdSave' cssclass='NBright_AcceptButton' commandname='saveconfig' />]";
			headTempl += "</div><div>";

			foreach (var secName in configSecList)
			{
                headTempl += "<a href='" + EditUrl("configsec", secName, "AdminConfig") + "' >" + secName + "</a> ";
			}
			headTempl += "</div>";


			//Add section menu to the header.
        	configSec = Utils.RequestQueryStringParam(Context, "configsec");
			if (configSec == "") configSec = "general";
			var dataTempl = Utils.ConfigConvertToTemplate(configDic, configSec);

        	rpDataH.ItemTemplate = new GenXmlTemplate(headTempl);
			rpData.ItemTemplate = new GenXmlTemplate(dataTempl);
			base.DoDisplay(rpDataH); // display the default data repeater, which we have a "non-data" template assigned.
			base.DoDisplay(rpData); // display the default data repeater, which we have a "non-data" template assigned.

        }

		protected override void EventCtrlEditItemCommand(object source, RepeaterCommandEventArgs e)
		{

			var cArg = e.CommandArgument.ToString();

			switch (e.CommandName.ToLower())
			{
                case "saveconfig":
                    Response.Redirect(EditUrl("configsec", configSec, "AdminConfig"));
					break;
			}

		}

    }
}
