using System;
using System.Collections.Generic;
using System.Web.UI.WebControls;
using DotNetNuke.Entities.Modules;
using DotNetNuke.Services.Exceptions;
using DotNetNuke.Entities.Modules.Actions;
using DotNetNuke.Security;
using DotNetNuke.Services.Localization;
using NBrightCore.common;
using NBrightCore.render;
using NBrightDNN;

namespace DotNetNuke.Modules.NBrightStore
{
	public partial class AdminDashboard : NBrightStoreAdminBase
    {

        override protected void OnInit(EventArgs e)
        {
			//Set base EntityTypeCode, MUST be done for all NBright child ctrls before OnInit
			// no data save on dashdoard so clear values
			base.EntityTypeCode = "";
			base.EntityTypeCodeLang = "";
			base.CtrlTypeCode = "AdminDashboard";

            base.OnInit(e);

			//All list display functions are processed via the parent class, we just initialize here.
			base.OnInitActivateData(); // assign the templates to the repeaters ("AdminDashboard_Data.html")
			base.DoDisplay(rpData); // display the default data repeater, which we have a "non-data" template assigned.

        }

		protected override void EventCtrlEditItemCommand(object source, RepeaterCommandEventArgs e)
		{

			var cArg = e.CommandArgument.ToString();

			switch (e.CommandName.ToLower())
			{
				case "admindashboard":
					Response.Redirect(EditUrl("AdminDashboard"));
					break;
				case "adminproducts":
					Response.Redirect(EditUrl("AdminProducts"));
					break;
			}

		}

    }
}
