using System;
using System.Collections.Generic;
using System.Web.UI.WebControls;
using DotNetNuke.Common;
using DotNetNuke.Entities.Modules;
using DotNetNuke.Services.Exceptions;
using DotNetNuke.Entities.Modules.Actions;
using DotNetNuke.Security;
using DotNetNuke.Services.Localization;
using NBrightCore.common;
using NBrightCore.render;
using NBrightDNN;

namespace DotNetNuke.Modules.NBrightStore
{
	public partial class AdminEntry : PortalModuleBase, IActionable 
    {

        const string SkinSrcAdmin = "?SkinSrc=%2fDesktopModules%2fNBright%2fNBrightStore%2fSkins%2fNWB_nbright%2fNormal";

        override protected void OnInit(EventArgs e)
        {

            var objTCtrl = new NBrightCore.TemplateEngine.TemplateController(MapPath(ControlPath));
			var strItemTemplate = objTCtrl.GetTemplateData("AdminEntry.html", Utils.GetCurrentCulture());

            base.OnInit(e);

            rpData.ItemTemplate = new GenXmlTemplate(strItemTemplate);

        }

        protected override void OnLoad(EventArgs e)
        {

            base.OnLoad(e);

            if (Page.IsPostBack == false)
            {
                PageLoad();
            }
        }

        private void PageLoad()
        {
            try
            {
                // display body
                var obj = new NBrightInfo();
                obj.XMLData = "<genxml></genxml>";
                var l = new List<object> { obj };
                rpData.DataSource = l;
                rpData.DataBind();
            }
            catch (Exception exc) //Module failed to load
            {
                Exceptions.ProcessModuleLoadException(this, exc);
            }
        }


        protected void CtrlItemCommand(object source, RepeaterCommandEventArgs e)
        {
            var cArg = e.CommandArgument.ToString();

            switch (e.CommandName.ToLower())
            {
				case "admindashboard":
                    Response.Redirect(EditUrl("AdminDashboard") + SkinSrcAdmin);
                    break;
				case "admindashboardpage":
                    Response.Redirect(Globals.ResolveUrl("~/DesktopModules/NBright/NBrightStore/Manager.aspx?mid=" + ModuleId.ToString()));
                    break;
            }

        }

        #region Optional Interfaces

        public ModuleActionCollection ModuleActions
        {
            get
            {
                var actions = new ModuleActionCollection();

				actions.Add(GetNextActionID(), Localization.GetString("AdminDashboard", this.LocalResourceFile), "", "", "", EditUrl("AdminDashboard") + SkinSrcAdmin, false, SecurityAccessLevel.Admin, true, false);
                return actions;
            }
        }

        #endregion

    }
}
