using System;
using System.Collections.Generic;
using System.Web.UI.WebControls;
using DotNetNuke.Entities.Modules;
using DotNetNuke.Services.Exceptions;
using DotNetNuke.Entities.Modules.Actions;
using DotNetNuke.Security;
using DotNetNuke.Services.Localization;
using NBrightCore.common;
using NBrightCore.render;
using NBrightDNN;
using System.Xml;

namespace DotNetNuke.Modules.NBrightStore
{
    public partial class AdminImages : NBrightStoreAdminBase
	{

		#region Load Event Handlers

        override protected void OnInit(EventArgs e)
        {

			//Set base EntityTypeCode, MUST be done for all NBright child ctrls before OnInit
			base.EntityTypeCode = "IMG";
            base.EntityTypeCodeLang = "IMGLANG";
			base.CtrlTypeCode = "AdminImages";

            base.UploadFolder = "NBrightStoreImages";
            
			base.OnInit(e);

			// Installation wide template, so use controlpath, so templates are stored in the module file structure.
			if (base.ItemId == "")
			{
				//All list display functions are processed via the parent class, we just initialize here.
				base.OnInitActivateList(true, true, MapPath(ControlPath));

			}
			else
			{
				// All data templates process by parent class, we just initialize here.
				base.OnInitActivateData();
			}

		}

		#endregion

		protected override void EventAfterUpdateData(NBrightInfo objInfo)
		{
            if (UInfo.FromItemId != "")
            {
                // deal with product level images
                var objPInfo = ModCtrl.GetInfo(Convert.ToInt32(UInfo.FromItemId));
                if (objPInfo != null)
                {
                    objInfo.AddXref("prdimg", UInfo.FromItemId);
                    objPInfo.AddXref("prdimg", objInfo.ItemID.ToString());

                    ModCtrl.UpdateInfo(objInfo);
                    ModCtrl.UpdateInfo(objPInfo);
                    if (UInfo.RtnUrl != "")
                    {
                        var rtnUrl = UInfo.RtnUrl;

                        //clear down user redirect data
                        UInfo.FromItemId = ""; 
                        UInfo.RtnUrl = "";
                        UInfo.Save();

                        Response.Redirect(rtnUrl);
                    }
                }
            }
		}

        protected override void EventAfterLoadDisplayData()
        {

        }

	}
}
