using System;
using System.Collections;
using System.Collections.Generic;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml;
using DotNetNuke.Common;
using DotNetNuke.Common.Utilities;
using DotNetNuke.Entities.Tabs;
using DotNetNuke.Services.Exceptions;
using DotNetNuke.Entities.Modules;
using NBrightCore.common;
using NBrightCore.render;
using NBrightDNN;


namespace DotNetNuke.Modules.NBrightStore
{

    /// -----------------------------------------------------------------------------
    /// <summary>
    /// The Settings class manages Module Settings
    /// </summary>
    /// -----------------------------------------------------------------------------
    public partial class AdminProductXref : NBrightStoreAdminBase 
    {
        
        #region Load Event Handlers

        override protected void OnInit(EventArgs e)
        {

            //Set base EntityTypeCode, MUST be done for all NBright child ctrls before OnInit
            base.EntityTypeCode = "PRD";
			base.EntityTypeCodeLang = "PRDLANG"; // Specify to enable langauge records.
            base.CtrlTypeCode = "AdminProductXref";

			//Remove any cache for the module -1, we don't want any cache in BO
			//All entry xref records are portal wide, hence -1 in cahce key.
			NBrightStoreUtils.RemoveModCache(-1);

            base.OnInit(e);

            base.HideMenu();

            rblSelectLang.Visible = false;

            // use local template control, so we pickup templates from NB_Index module.
            var els = TemplCtrl.GetTemplateData(CtrlTypeCode + "_" + NBrightStoreUtils.ModuleEventCodes.selectsearch, Utils.GetCurrentCulture());
            var elh = TemplCtrl.GetTemplateData(CtrlTypeCode + "_" + NBrightStoreUtils.ModuleEventCodes.selectheader, Utils.GetCurrentCulture());
            var elb = TemplCtrl.GetTemplateData(CtrlTypeCode + "_" + NBrightStoreUtils.ModuleEventCodes.selectbody, Utils.GetCurrentCulture());
            var elf = TemplCtrl.GetTemplateData(CtrlTypeCode + "_" + NBrightStoreUtils.ModuleEventCodes.selectfooter, Utils.GetCurrentCulture());

            // replace Settings tags for ajax to work.
            elb = ModCtrl.ReplaceUrlTokens(elb);
            els = ModCtrl.ReplaceUrlTokens(els);


            base.OnInitActivateList(elh, elb, elf, els);
        }

        protected override void OnLoad(EventArgs e)
        {
            base.ItemId = ""; // clear itemid so we do the list

            base.OnLoad(e);

            if (Page.IsPostBack == false)
            {
                PageLoad();
            }
        }

        private void PageLoad()
        {
            try
            {

            }
            catch (Exception exc) //Module failed to load
            {
                Exceptions.ProcessModuleLoadException(this, exc);
            }
        }

        #endregion

        #region "Event handlers"

        #endregion

        #region "Methods"

        #endregion


    }

}

