﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.UI.WebControls;
using System.Xml;
using NBrightCore.render;
using NBrightDNN;
using DotNetNuke.Modules.NBrightStore.Components;
using NBrightCore.common;

namespace DotNetNuke.Modules.NBrightStore
{
	public class ProductFunctions
	{

		#region "Entities"
        //Entities are object addtached the to the product data, model, images, documents, options. 

        public static List<NBrightInfo> GetEntityList(NBrightInfo objInfo, String EntityName)
		{
			var l = new List<NBrightInfo>();

            var xmlNodList = objInfo.XMLDoc.SelectNodes("genxml/" + EntityName + "/genxml");
			if (xmlNodList != null)
			{
				//--------------------------------------------------
				//do non-langauge display
				//--------------------------------------------------
				// build generic list to bind to rpModels List
				foreach (XmlNode xNod in xmlNodList)
				{
					var obj = new NBrightInfo();
					// add the models data to this temp obj
					obj.XMLData = xNod.OuterXml;
					obj.ItemID = objInfo.ItemID;
					l.Add(obj);
				}
			}
			return l;
		}

        public static List<NBrightInfo> GetEntityLangList(NBrightInfo objInfo, NBrightInfo objLangInfo, String EntityName)
		{

			var l = new List<NBrightInfo>();
			//--------------------------------------------------
			//do langauge display
			//--------------------------------------------------
			if (objLangInfo != null && objInfo != null)
			{
				var xmlNodList = objInfo.XMLDoc.SelectNodes("genxml/" + EntityName + "/genxml");
				// build generic list to bind to rpModelsLang List
                var xmlNodListLang = objLangInfo.XMLDoc.SelectNodes("genxml/" + EntityName + "/genxml");
				if (xmlNodList != null && xmlNodList.Count > 0)
				{
					var lp = 0;
					foreach (XmlNode xNod in xmlNodList)
					{
						var obj = new NBrightInfo();
						// add the models data to this temp obj
						if (xmlNodListLang != null && xmlNodListLang[lp] != null)
						{
							obj.XMLData = xmlNodListLang[lp].OuterXml;
						}
						obj.ItemID = objLangInfo.ParentItemId;
						l.Add(obj);
						lp = lp + 1;
					}
				}
			}
			return l;
		}

        public static NBrightInfo AddEntity(NBrightInfo objInfo, String EntityName, int NumerToAdd = 1, String genxmlData = "<genxml></genxml>")
        {
            var xNod = objInfo.XMLDoc.SelectSingleNode("genxml/" + EntityName.ToLower());
            if (xNod != null)
            {
                var strModelXML = "";
                for (int i = 0; i < NumerToAdd; i++)
                {
                    strModelXML += genxmlData;
                }
                // Create a document fragment to contain the XML to be inserted. 
                var docFrag = objInfo.XMLDoc.CreateDocumentFragment();
                // Set the contents of the document fragment. 
                docFrag.InnerXml = strModelXML;
                //Add new model data
                xNod.AppendChild(docFrag);
                objInfo.XMLData = objInfo.XMLDoc.OuterXml;
            }
            return objInfo;
        }

        public static NBrightInfo InsertEntityData(NBrightInfo objInfo, Repeater rpEntity, String entityName,String FolderMapPath = "")
		{
			var strModelXML = "<" + entityName + ">";
            foreach (RepeaterItem i in rpEntity.Items)
			{
                if (GenXmlFunctions.GetField(rpEntity, "chkDelete", i.ItemIndex) == "False")
                {
					strModelXML += GenXmlFunctions.GetGenXml(i, "", FolderMapPath);
                }
			}
            strModelXML += "</" + entityName + ">";

			// Create a document fragment to contain the XML to be inserted. 
			var docFrag = objInfo.XMLDoc.CreateDocumentFragment();
			// Set the contents of the document fragment. 
			docFrag.InnerXml = strModelXML;
			//Add new data
			if (objInfo.XMLDoc.DocumentElement != null) objInfo.XMLDoc.DocumentElement.AppendChild(docFrag);
			objInfo.XMLData = objInfo.XMLDoc.OuterXml;
			return objInfo;
		}

		public static NBrightInfo InsertEntityLangData(NBrightInfo objLangInfo, Repeater rpEntity, Repeater rpEntityLang, String entityName, String FolderMapPath = "")
		{

            var strModelXML = "<" + entityName + ">";
            foreach (RepeaterItem i in rpEntityLang.Items)
			{
                if (GenXmlFunctions.GetField(rpEntity, "chkDelete", i.ItemIndex) == "False")
                {
					strModelXML += GenXmlFunctions.GetGenXml(i, "", FolderMapPath);
                }
            }
            strModelXML += "</" + entityName + ">";

			// Create a document fragment to contain the XML to be inserted. 
			var docFrag = objLangInfo.XMLDoc.CreateDocumentFragment();
			// Set the contents of the document fragment. 
			docFrag.InnerXml = strModelXML;
			//Add new model data
			if (objLangInfo.XMLDoc.DocumentElement != null) objLangInfo.XMLDoc.DocumentElement.AppendChild(docFrag);
			objLangInfo.XMLData = objLangInfo.XMLDoc.OuterXml;

			return objLangInfo;
		}

		#endregion


        public static string GetRelatedProducts(int portalId, string parentItemId, string lang, string templatePrefix, string controlMapPath)
        {
            return GetRelatedXref(portalId, parentItemId, lang, templatePrefix, "prdxref", "PRDLANG", controlMapPath);
        }

        public static string GetProductImgs(int portalId, string parentItemId, string lang, string templatePrefix, string controlMapPath)
        {
            return GetRelatedXref(portalId, parentItemId, lang, templatePrefix, "prdimg", "", controlMapPath);
        }

        public static string GetProductOpts(int portalId, string parentItemId, string lang, string templatePrefix, string controlMapPath)
        {
            return GetRelatedXref(portalId, parentItemId, lang, templatePrefix, "prdopt", "", controlMapPath);
        }

        public static string GetRelatedXref(int portalId, string parentItemId, string lang, string templatePrefix, string nodeName, string entityTypeCodeLang, string controlMapPath)
        {
            var strOut = "";
            if (Utils.IsNumeric(parentItemId))
            {

                var objCtrl = new NBrightStoreController();

                var templCtrl = new NBrightCore.TemplateEngine.TemplateController(controlMapPath);

                var hTempl = templCtrl.GetTemplateData(templatePrefix + "_" + NBrightStoreUtils.ModuleEventCodes.selectedheader, Utils.GetCurrentCulture());
                var bTempl = templCtrl.GetTemplateData(templatePrefix + "_" + NBrightStoreUtils.ModuleEventCodes.selectedbody, Utils.GetCurrentCulture());
                var fTempl = templCtrl.GetTemplateData(templatePrefix + "_" + NBrightStoreUtils.ModuleEventCodes.selectedfooter, Utils.GetCurrentCulture());

                // replace tags for ajax to work.
                hTempl = objCtrl.ReplaceUrlTokens(hTempl);
                bTempl = objCtrl.ReplaceUrlTokens(bTempl);
                fTempl = objCtrl.ReplaceUrlTokens(fTempl);

                var objPInfo = objCtrl.GetInfo(Convert.ToInt32(parentItemId));
                if (objPInfo != null)
                {
                    var nodList = objPInfo.XMLDoc.SelectNodes("genxml/" + nodeName + "/id");
                    var objList = new List<NBrightInfo>();

                    foreach (XmlNode xNod in nodList)
                    {
                        if (xNod != null)
                        {
                            var o = objCtrl.GetDataWithLang(portalId, -1, xNod.InnerText, lang, entityTypeCodeLang);
                            if (o != null)
                            {
                                objList.Add(o);
                            }
                        }
                    }

                    var obj = new NBrightDNN.NBrightInfo();
                    strOut += NBrightCore.render.GenXmlFunctions.RenderRepeater(obj, hTempl);
                    strOut += NBrightCore.render.GenXmlFunctions.RenderRepeater(objList, bTempl);
                    strOut += NBrightCore.render.GenXmlFunctions.RenderRepeater(obj, fTempl);
                }
            }

            return strOut;
        }

        public static string GetRelatedCats(int portalId, string parentItemId, string lang, string templatePrefix, string controlMapPath, Boolean AllowCache = true)
        {
            var strOut = "";
            if (Utils.IsNumeric(parentItemId))
            {
                if (!AllowCache)
                {
                    //Remove any cache for the module -1, we don't want any cache in BO
                    //All xref records are portal wide, hence -1 in cahce key.
                    NBrightStoreUtils.RemoveModCache(-1);
                }

                var objCtrl = new NBrightStoreController();

                var templCtrl = new NBrightCore.TemplateEngine.TemplateController(controlMapPath);

                var hTempl = templCtrl.GetTemplateData(templatePrefix + "_" + NBrightStoreUtils.ModuleEventCodes.selectedheader, Utils.GetCurrentCulture());
                var bTempl = templCtrl.GetTemplateData(templatePrefix + "_" + NBrightStoreUtils.ModuleEventCodes.selectedbody, Utils.GetCurrentCulture());
                var fTempl = templCtrl.GetTemplateData(templatePrefix + "_" + NBrightStoreUtils.ModuleEventCodes.selectedfooter, Utils.GetCurrentCulture());

                // replace Settings tags for ajax to work.
                hTempl = objCtrl.ReplaceUrlTokens(hTempl);
                bTempl = objCtrl.ReplaceUrlTokens(bTempl);
                fTempl = objCtrl.ReplaceUrlTokens(fTempl);

                var strFilter = " and parentitemid = " + parentItemId;
                var strOrderBy = GenXmlFunctions.GetSqlOrderBy(hTempl);
                if (strOrderBy == "")
                {
                    strOrderBy = GenXmlFunctions.GetSqlOrderBy(bTempl);
                }

                var l = objCtrl.GetListWithLang(portalId, -1, "CATXREF", strFilter, strOrderBy);
                var objList = new List<NBrightInfo>();

                foreach (var objXref in l)
                {
                    var o = objCtrl.GetDataWithLang(portalId, -1, objXref.XrefItemId.ToString(""), lang, "CATEGORYLANG");
                    if (o != null)
                    {
                        if (objXref.GetXmlProperty("genxml/hidden/defaultcat") != "")
                        {
                            // set the default flag in the category, for display in the entry only.
                            o.SetXmlProperty("genxml/hidden/defaultcat", "True");
                        }
                        o.GUIDKey = objXref.ItemID.ToString(); // overwrite with xref itemid for delete ajax action.
                        o.TextData = o.GetXmlProperty("genxml/lang/genxml/textbox/txtname"); // set for sort
                        objList.Add(o);
                        objList.Sort(delegate(NBrightInfo p1, NBrightInfo p2) { return p1.TextData.CompareTo(p2.TextData); });
                    }
                }

                var obj = new NBrightDNN.NBrightInfo();
                strOut += NBrightCore.render.GenXmlFunctions.RenderRepeater(obj, hTempl);
                strOut += NBrightCore.render.GenXmlFunctions.RenderRepeater(objList, bTempl);
                strOut += NBrightCore.render.GenXmlFunctions.RenderRepeater(obj, fTempl);

            }

            return strOut;
        }

        public static NBrightInfo CalculateModels(NBrightInfo objInfo,String controlMapPath)
        {
            var objCtrl = new NBrightStoreController();
            var optList = new List<NBrightInfo>();

            // get list of active options for product models (Those with active stock)
            var xmlOptList = objInfo.XMLDoc.SelectNodes("genxml/prdopt/id");
            foreach (XmlNode xNod in xmlOptList)
            {
                if (Utils.IsNumeric(xNod.InnerText))
                {
                    var objOpt = objCtrl.GetInfo(Convert.ToInt32(xNod.InnerText));
                    if (objOpt != null)
                    {
                        if (objOpt.GetXmlProperty("genxml/checkbox/chkstockcontrol").ToLower() == "true")
                        {
                            optList.Add(objOpt);
                        }
                    }

                }

            }

            //sort into ItemId order so we get the same modelcode created.
            optList.Sort(delegate(NBrightInfo p1, NBrightInfo p2)
            {
                return p1.ItemID.CompareTo(p2.ItemID);
            });

            //Build modelCode list
            int lp1 = 0;
            var mcList = new List<String>();
            lp1 = 0;
            if (optList.Count == 1)
            {
                // only 1 option with stock, so no need to do a recursive build.
                var xmlNodList2 = optList[0].XMLDoc.SelectNodes("genxml/optionval/genxml");
                foreach (XmlNode xNod2 in xmlNodList2)
                {
                    mcList.Add(xNod2.SelectSingleNode("textbox/txtoptionvalue").InnerText);
                }
            }
            else
            {
                // do recursive build on options.
                while (lp1 < (optList.Count - 1))
                {
                    mcList = BuildModelCodes(optList, lp1, "", "", mcList);
                    lp1++;
                }
            }


            //Merge with existinhg models
            var TemplCtrl = new NBrightCore.TemplateEngine.TemplateGetter(controlMapPath,controlMapPath);
            var rpEntity = new Repeater();
            var rpEntityLang = new Repeater();
         	var strTemplate = TemplCtrl.GetTemplateData("AdminProducts_Models.html", Utils.GetCurrentCulture());

            // remove models no longer needed
            XmlNodeList nodes = objInfo.XMLDoc.SelectNodes("genxml/models/genxml");
            for (int i = nodes.Count - 1; i >= 0; i--)
            {
                var mCode = nodes[i].SelectSingleNode("hidden/modelcode");
                if (mCode != null)
                {
                    if (!mcList.Contains(mCode.InnerText))
                    {
                        nodes[i].ParentNode.RemoveChild(nodes[i]);
                    }
                }
                else
                {
                    // no modelcode, invalid, so remove
                    nodes[i].ParentNode.RemoveChild(nodes[i]);
                }

            }
            
            // save changes back to the product object
            objInfo.XMLData = objInfo.XMLDoc.OuterXml;

            // add new models
            foreach (var modelCode in mcList)
            {
                if (objInfo.XMLDoc.SelectSingleNode("genxml/models/genxml/hidden/modelcode[.='" + modelCode + "']") == null)
                {
                    var obj = new NBrightInfo();
                    rpEntity = GenXmlFunctions.InitRepeater(obj, strTemplate);
                    GenXmlFunctions.SetHiddenField(rpEntity.Items[0], "modelcode", modelCode);
                    var strXML = GenXmlFunctions.GetGenXml(rpEntity, 0);
                    objInfo = ProductFunctions.AddEntity(objInfo, "models", 1, strXML);
                }
            }

            return objInfo;
        }

        private static List<String> BuildModelCodes(List<NBrightInfo> optList, int lpPos, String pmodelCode, String modelCode, List<String> mcList)
        {
            // COMMENT(Dave Lee): Dave, if your looking at this in the future... 
            // YES!!! you did stuggle to pop this out of your tiny mad mind...
            // and YES!! your still just as stupid now as then! 
            var xmlNodList2 = optList[lpPos].XMLDoc.SelectNodes("genxml/optionval/genxml");
            foreach (XmlNode xNod2 in xmlNodList2)
            {
                if ((pmodelCode == "") | (pmodelCode != modelCode)) // only want to add the first value to the modelcode
                {
                    modelCode = pmodelCode + xNod2.SelectSingleNode("textbox/txtoptionvalue").InnerText + "-";
                    if (lpPos == (optList.Count - 1)) // only add the last child of the tree
                    {
                        mcList.Add(modelCode.TrimEnd('-'));
                    }
                    if (lpPos < (optList.Count - 1)) // end recussive loop on last child.
                    {
                        mcList = BuildModelCodes(optList, lpPos + 1, modelCode, "", mcList);
                    }
                }
            }
            return mcList;
        }


    }
}
