﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using DotNetNuke.Common;
using DotNetNuke.Common.Utilities;
using DotNetNuke.Entities.Modules;
using DotNetNuke.Modules.NBrightStore;
using NBrightDNN;

namespace DotNetNuke.Modules.NBrightStore
{
    public partial class Manager : System.Web.UI.Page
    {
        private const string DefaulControlKey = "AdminDashBoard";

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);

            // Load the right control into the page
            LoadAdminControl();
        }

        private void LoadAdminControl()
        {
            // find the moduleId
            int moduleId = Null.NullInteger;
            if (Request.QueryString.AllKeys.Contains("mid"))
                int.TryParse(Request.QueryString["mid"], out moduleId);

            // if there's no moduleId, get out
            if(moduleId == Null.NullInteger)
                Response.Redirect(Globals.NavigateURL("Access Denied"), true);

            // fetch the configuration for the module
            var moduleConfiguration = DnnUtils.GetModuleinfo(moduleId);

            // find the requested control
            var controlKey = Request.QueryString["ctl"];
            if (string.IsNullOrEmpty(controlKey)) controlKey = DefaulControlKey;
            
            // find the control to load
            var controlSrc = String.Format("{0}.ascx", controlKey);

            // load the control, cast it to the base page
            var control = (NBrightStoreAdminBase)LoadControl(controlSrc);

            // set the required stuff for DNN
            control.ModuleConfiguration = moduleConfiguration;

            // add the control to the page
            plhAdminControl.Controls.Add(control);
        }

        protected void Page_Load(object sender, EventArgs e)
        {

        }
    }
}